'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'part of lock.bas
'requires PowerBasic 2.1 or higher to compile
'
'11/12/92 - added force of locseed to 4 if < 4 to prevent display pause
'           probably don't need force of topline or firstcol now
'11/05/92 - changed "lost in loop" count to 10 instead of 20
'11/04/92 - changed fixtop to force topline to 4 - 22 and firstcol to >= 4
'10/12/92 - added additional checks for topline < 3
'08/07/92 - added check for first column < 3
'05/04/92 - added check for topline < 2
'04/30/92 - added initialization of 'firstcol'
'04/16/92 - added lines to check for "lost in loop"
'10/28/91 - added "mod 8" to bcolor increment in block after line 213
'10/08/91 - added print of free space info
'05/31/91 - changed random character code at line 280
'05/29/91 - added box around displayed text
'04/04/91 - changed 'do while' to 'while' in main loop to keep 'sp' happy
'03/05/91 - changed character set to 166 -> 255 only
'02/26/91 - added check for bgnd out of range
'02/21/91 - added option for message from command line instead of 'LOCKED'
'02/19/91 - added banner of "LOCKED" at startup and every 5 minutes
'02/18/91 - changed random location finder to always print somewhere
'<e> burnsub, banner, instat, fixtop, banner, blockprint, incr, decr
SUB burnsub  'handles positioning, color, blink, text box
200 rem
  SHARED maxcolor,quot,quot$,ver$,topline,oldtop,dtime,fgnd,bgnd,oldquot$
  SHARED fcolor,bcolor,meminfo
  pcnt& = 0
  skipmem = 0
  seed = 1
  firstcol = 30
  startmins = val(mid$(time$,4,2))
  holdmins = startmins
201 rem
  randomize timer
  call banner
  if meminfo = 1 then
    locate 20,1
    print "returned from banner in first call"
  end if
  maxrow = 25
  maxcol = 80
202 rem
  oldseed = 11
  oldb = 9
  oldf = 33
  xmin = 5
210 rem
  while not instat   'was "do ...."
    oldseed = seed
'next 7 lines call the banner routine to clear the screen and print "LOCKED"
' in big letters every xmin minutes
    if dtime = 1 and quot = 0 then
      curmins = val(mid$(time$,4,2))
      if abs(startmins - curmins) mod xmin = 0 then
	if holdmins <> curmins then
	  call banner
	  holdmins = curmins
	end if
      end if
    end if
    seed = val(right$(time$,1))             'seconds units
    locseed = val(right$(time$,2))          'actual seconds
    if locseed < 4 then locseed = 4     'fix to avoid delay if < 4 11/12/92
    loc3 = int(locseed/3)
    loc4 = int(locseed/4)
211 rem                   print the box with LOCK in it
      if oldseed <> seed then               'new second
	if dtime = 1 and quot = 0 then quot$ = time$
	if quot <> 0 then
	  fcol2 = int(firstcol/2)+1
	  locate 22,fcol2
212 rem
	  print chr$(218);string$(8,196);chr$(191);
	  locate 23,fcol2
	  print chr$(179);"LOCK ";ver$;chr$(179);
	  locate 24,fcol2
	  print chr$(192);string$(8,196);chr$(217);
	  lcol2 = fcol2 + 8
	end if
	oldf = fcolor
	oldb = bcolor
213 rem
	fcolor = int(rnd(seed)*16)   'maxcolor) force text to non-blink
	fcolor = abs(fcolor)         ' 11/11/91
	bcolor = int(rnd(seed)*8)
	bcolor = abs(bcolor)         ' 11/11/91
	if fcolor = oldf then fcolor = (fcolor + 12) mod 16  'maxcolor
	if bcolor = oldb then bcolor = (bcolor + 1) mod 8
    while ((fcolor mod 8 = bcolor) or (abs(fcolor mod 8 - bcolor) < 3) or fcolor > 15)  'or (abs(fcolor - bcolor) mod 8 = 0)
	incr fcolor, 2        'was 3 (11/5/92)
	fcolor = fcolor mod 16
    wend
214 rem
      color fcolor, bcolor
215 rem
      topline = loc4 + seed + 1 'was 5
      if topline < 4 then topline = 4   'changed 10/12/92 - added 5/4/92
216 rem
       call fixtop
217 rem
      if topline < 4 then topline = 4
      if topline = oldtop + 1 then incr topline
      if topline = oldtop then incr topline,4
      if topline > 22 then topline = int(topline/4)  'was 2
      call fixtop
      oldtop = topline
      if topline < 4 then topline = 4
      if quot <> 0 then
	qlen = len(quot$) + 4
	if dtime = 1 and qlen < 33 then qlen = qlen + len(time$) + 1
      end if
218 rem
      botline = topline + 2
      firstcol = locseed + seed + 1
      if firstcol < 4 then firstcol = 4  'changed from 2 to 3 8/7/92
230 rem                             use LOCK in text box
      if quot = 0 and dtime = 0 then
	oldcol = firstcol
	lastcol = firstcol + 12   'was 10
	if lastcol > 78 then
	  firstcol = int(firstcol/3)
	  lastcol = firstcol + 12
	end if
	locate topline, firstcol
	print chr$(201);string$(10,205);chr$(187);
	locate topline + 1,firstcol
	print chr$(186);" LOCK ";ver$;" ";chr$(186);
	locate botline,firstcol
	print chr$(200);string$(10,205);chr$(188);
      else
	if firstcol < 4 then firstcol = 4
	if dtime = 1 and quot = 0 then  'put time in string to print
	  quot$ = time$
	  qlen = len(quot$) + 4
	end if
	if firstcol + qlen > 79 then firstcol = int(firstcol/4)  'was 2
	if firstcol = oldcol then
	  firstcol = firstcol + 2
	  if firstcol + qlen > 79 then
	    firstcol = int((firstcol +locseed)/4)
	    if firstcol = oldcol then incr firstcol,2
	    if firstcol < 4 then firstcol = 4
	  end if
	end if
	oldcol = firstcol
	lastcol = firstcol + qlen
'	if topline = 4 and firstcol = 4 then
'	  locate 10,10
'	  print " bad place "
'	end if
	locate topline,firstcol
	print chr$(201);string$(qlen-2,205);chr$(187);
	locate topline +1, firstcol
	print chr$(186);" ";quot$;       'print string in box
	if dtime = 1 and quot > 0 and len(quot$)<29 then print " ";time$; 'add time to box
	print " ";chr$(186);
	locate botline,firstcol
	print chr$(200);string$(qlen-2,205);chr$(188);
      end if
255 rem
      incr botline
      incr lastcol
260 rem
      if meminfo = 1 and skipmem = 0 then locate 4,40:print "botline="botline,"lastcol=";lastcol
      if botline = 25 then
	incr botcount
	if botcount = 2 then
	  botcount = 0
	  color bcolor, fcolor mod 8
	  locate 25,1
	  print space$(79)
	  decr topline,2
	end if
      end if
    end if
      lin = int(rnd(seed) * maxrow)+1
      col = int(rnd(locseed) * maxcol)+1
      if lin = 0 then lin = 25
      if col = 0 then col = 1
      if lin > 25 then lin = 25     'int(lin/2)
      if col > 80 then col = int(col/2)
270 rem
      if (lin < topline) or (lin > botline) or (col < firstcol) or (col > lastcol) then
	if (lin < 22) or ((col < fcol2) or (col > lcol2)) then locate lin,col
      else
	lin = (lin + 4) mod 25 + 1
	col = (col + 12) mod 80 + 1
	locate lin, col
      end if
      fgnd = int(rnd(locseed)*maxcolor)
      bgnd = int(rnd(locseed)*loc4)
      bgnd = bgnd mod 8           'added 2/26/91
      if meminfo = 1 and skipmem = 0 then locate 3,40:print "after line 270";pcnt&:incr skipmem:locate lin,col
      incr pcnt
      passcnt = 0
      while ((fgnd mod 8) = bgnd) or (abs((fgnd mod 8) - bgnd) < 3)
	incr passcnt
	if passcnt > 10 then    ' added 4 lines to check for "lost in loop"
	  incr bgnd             ' 4/16/92 - jec
	  bgnd = bgnd mod 8
	end if
	incr fgnd,2         'was 3 (11/5/92)
	fgnd = fgnd mod maxcolor
      wend
280 rem
      color fgnd, bgnd
      randchar = int(rnd(locseed)*90)+166
      if randchar < 166 or randchar > 255 then goto 280
      print chr$(randchar);
  wend
  k$ = inkey$   'this eats the keystroke that switches to the password screen
  color 7,0
END SUB

SUB fixtop  'keeps top line that box is printed on within range
      if topline = oldtop then
	incr topline,2
	if topline < 4 or topline > 22 then topline = 4
	exit sub
      end if
      if topline = oldtop - 2 then
	incr topline,4
	if topline < 4 or topline > 22 then topline = 4
	exit sub
      end if
      if topline = oldtop + 1 then
	incr topline
	if topline < 4 or topline > 22 then topline = 4
      end if
END SUB 'fixtop

SUB banner  'banners LOCKED
290 rem
  SHARED fgnd, bgnd, bl$, meminfo
  if fgnd = bgnd then
    color 4,7     '7,4
  else
    color fgnd, bgnd
  end if
  cls
  locate 1,76:print "jec";
  lockst = 10
  locate lockst, 1
  bl$ = "        LL           OOO       CCCCC    KK    KK   EEEEEEE   DDDDDD"
  call blockprint
  bl$ = "        LL          OOOOO     CC   CC   KK   KK    EE        DD   DD"
  call blockprint
  bl$ = "        LL         OO   OO   CC         KK  KK     EE        DD    DD"
  call blockprint
  bl$ = "        LL         OO   OO   CC         KK KK      EE        DD     DD"
  call blockprint
  bl$ = "        LL         OO   OO   CC         KKKK       EEEEE     DD     DD"
  call blockprint
  bl$ = "        LL         OO   OO   CC         KK KK      EE        DD     DD"
  call blockprint
  bl$ = "        LL         OO   OO   CC         KK  KK     EE        DD    DD"
  call blockprint
  bl$ = "        LL          OOOOO     CC   CC   KK   KK    EE        DD   DD"
  call blockprint
  bl$ = "        LLLLLLL      OOO       CCCCC    KK    KK   EEEEEEE   DDDDDD"
  call blockprint
  if meminfo = 1 then
    locate 2,1
    print "string segments: ";fre(0);"  free data memory: ";fre(-1);"  unused stack: "; fre(-2)
    delay .5
  end if
END SUB

SUB blockprint   'replaces spaces with solid block
300 rem
  shared bl$
  for k=1 to len(bl$)
    if mid$(bl$,k,1) <> " " then mid$(bl$,k,1)=chr$(219)
  next k
  print bl$
END SUB
